"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.UpdateNotificationRuleResult = exports.UpdateNotificationRuleRequest = exports.UntagResourceResult = exports.UntagResourceRequest = exports.UnsubscribeResult = exports.UnsubscribeRequest = exports.TagResourceResult = exports.TagResourceRequest = exports.SubscribeResult = exports.SubscribeRequest = exports.ListTargetsResult = exports.ListTargetsRequest = exports.ListTargetsFilter = exports.ListTargetsFilterName = exports.ListTagsForResourceResult = exports.ListTagsForResourceRequest = exports.ListNotificationRulesResult = exports.NotificationRuleSummary = exports.ListNotificationRulesRequest = exports.ListNotificationRulesFilter = exports.ListNotificationRulesFilterName = exports.ListEventTypesResult = exports.ListEventTypesRequest = exports.ListEventTypesFilter = exports.ListEventTypesFilterName = exports.InvalidNextTokenException = exports.ResourceNotFoundException = exports.DescribeNotificationRuleResult = exports.TargetSummary = exports.TargetStatus = exports.EventTypeSummary = exports.DescribeNotificationRuleRequest = exports.DeleteTargetResult = exports.DeleteTargetRequest = exports.DeleteNotificationRuleResult = exports.DeleteNotificationRuleRequest = exports.ValidationException = exports.ResourceAlreadyExistsException = exports.LimitExceededException = exports.CreateNotificationRuleResult = exports.CreateNotificationRuleRequest = exports.Target = exports.NotificationRuleStatus = exports.DetailType = exports.ConfigurationException = exports.ConcurrentModificationException = exports.AccessDeniedException = void 0;
const smithy_client_1 = require("@aws-sdk/smithy-client");
const CodestarNotificationsServiceException_1 = require("./CodestarNotificationsServiceException");
class AccessDeniedException extends CodestarNotificationsServiceException_1.CodestarNotificationsServiceException {
    constructor(opts) {
        super({
            name: "AccessDeniedException",
            $fault: "client",
            ...opts,
        });
        this.name = "AccessDeniedException";
        this.$fault = "client";
        Object.setPrototypeOf(this, AccessDeniedException.prototype);
        this.Message = opts.Message;
    }
}
exports.AccessDeniedException = AccessDeniedException;
class ConcurrentModificationException extends CodestarNotificationsServiceException_1.CodestarNotificationsServiceException {
    constructor(opts) {
        super({
            name: "ConcurrentModificationException",
            $fault: "client",
            ...opts,
        });
        this.name = "ConcurrentModificationException";
        this.$fault = "client";
        Object.setPrototypeOf(this, ConcurrentModificationException.prototype);
        this.Message = opts.Message;
    }
}
exports.ConcurrentModificationException = ConcurrentModificationException;
class ConfigurationException extends CodestarNotificationsServiceException_1.CodestarNotificationsServiceException {
    constructor(opts) {
        super({
            name: "ConfigurationException",
            $fault: "client",
            ...opts,
        });
        this.name = "ConfigurationException";
        this.$fault = "client";
        Object.setPrototypeOf(this, ConfigurationException.prototype);
        this.Message = opts.Message;
    }
}
exports.ConfigurationException = ConfigurationException;
var DetailType;
(function (DetailType) {
    DetailType["BASIC"] = "BASIC";
    DetailType["FULL"] = "FULL";
})(DetailType = exports.DetailType || (exports.DetailType = {}));
var NotificationRuleStatus;
(function (NotificationRuleStatus) {
    NotificationRuleStatus["DISABLED"] = "DISABLED";
    NotificationRuleStatus["ENABLED"] = "ENABLED";
})(NotificationRuleStatus = exports.NotificationRuleStatus || (exports.NotificationRuleStatus = {}));
var Target;
(function (Target) {
    Target.filterSensitiveLog = (obj) => ({
        ...obj,
        ...(obj.TargetAddress && { TargetAddress: smithy_client_1.SENSITIVE_STRING }),
    });
})(Target = exports.Target || (exports.Target = {}));
var CreateNotificationRuleRequest;
(function (CreateNotificationRuleRequest) {
    CreateNotificationRuleRequest.filterSensitiveLog = (obj) => ({
        ...obj,
        ...(obj.Name && { Name: smithy_client_1.SENSITIVE_STRING }),
        ...(obj.Targets && { Targets: obj.Targets.map((item) => Target.filterSensitiveLog(item)) }),
    });
})(CreateNotificationRuleRequest = exports.CreateNotificationRuleRequest || (exports.CreateNotificationRuleRequest = {}));
var CreateNotificationRuleResult;
(function (CreateNotificationRuleResult) {
    CreateNotificationRuleResult.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(CreateNotificationRuleResult = exports.CreateNotificationRuleResult || (exports.CreateNotificationRuleResult = {}));
class LimitExceededException extends CodestarNotificationsServiceException_1.CodestarNotificationsServiceException {
    constructor(opts) {
        super({
            name: "LimitExceededException",
            $fault: "client",
            ...opts,
        });
        this.name = "LimitExceededException";
        this.$fault = "client";
        Object.setPrototypeOf(this, LimitExceededException.prototype);
        this.Message = opts.Message;
    }
}
exports.LimitExceededException = LimitExceededException;
class ResourceAlreadyExistsException extends CodestarNotificationsServiceException_1.CodestarNotificationsServiceException {
    constructor(opts) {
        super({
            name: "ResourceAlreadyExistsException",
            $fault: "client",
            ...opts,
        });
        this.name = "ResourceAlreadyExistsException";
        this.$fault = "client";
        Object.setPrototypeOf(this, ResourceAlreadyExistsException.prototype);
        this.Message = opts.Message;
    }
}
exports.ResourceAlreadyExistsException = ResourceAlreadyExistsException;
class ValidationException extends CodestarNotificationsServiceException_1.CodestarNotificationsServiceException {
    constructor(opts) {
        super({
            name: "ValidationException",
            $fault: "client",
            ...opts,
        });
        this.name = "ValidationException";
        this.$fault = "client";
        Object.setPrototypeOf(this, ValidationException.prototype);
        this.Message = opts.Message;
    }
}
exports.ValidationException = ValidationException;
var DeleteNotificationRuleRequest;
(function (DeleteNotificationRuleRequest) {
    DeleteNotificationRuleRequest.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(DeleteNotificationRuleRequest = exports.DeleteNotificationRuleRequest || (exports.DeleteNotificationRuleRequest = {}));
var DeleteNotificationRuleResult;
(function (DeleteNotificationRuleResult) {
    DeleteNotificationRuleResult.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(DeleteNotificationRuleResult = exports.DeleteNotificationRuleResult || (exports.DeleteNotificationRuleResult = {}));
var DeleteTargetRequest;
(function (DeleteTargetRequest) {
    DeleteTargetRequest.filterSensitiveLog = (obj) => ({
        ...obj,
        ...(obj.TargetAddress && { TargetAddress: smithy_client_1.SENSITIVE_STRING }),
    });
})(DeleteTargetRequest = exports.DeleteTargetRequest || (exports.DeleteTargetRequest = {}));
var DeleteTargetResult;
(function (DeleteTargetResult) {
    DeleteTargetResult.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(DeleteTargetResult = exports.DeleteTargetResult || (exports.DeleteTargetResult = {}));
var DescribeNotificationRuleRequest;
(function (DescribeNotificationRuleRequest) {
    DescribeNotificationRuleRequest.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(DescribeNotificationRuleRequest = exports.DescribeNotificationRuleRequest || (exports.DescribeNotificationRuleRequest = {}));
var EventTypeSummary;
(function (EventTypeSummary) {
    EventTypeSummary.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(EventTypeSummary = exports.EventTypeSummary || (exports.EventTypeSummary = {}));
var TargetStatus;
(function (TargetStatus) {
    TargetStatus["ACTIVE"] = "ACTIVE";
    TargetStatus["DEACTIVATED"] = "DEACTIVATED";
    TargetStatus["INACTIVE"] = "INACTIVE";
    TargetStatus["PENDING"] = "PENDING";
    TargetStatus["UNREACHABLE"] = "UNREACHABLE";
})(TargetStatus = exports.TargetStatus || (exports.TargetStatus = {}));
var TargetSummary;
(function (TargetSummary) {
    TargetSummary.filterSensitiveLog = (obj) => ({
        ...obj,
        ...(obj.TargetAddress && { TargetAddress: smithy_client_1.SENSITIVE_STRING }),
    });
})(TargetSummary = exports.TargetSummary || (exports.TargetSummary = {}));
var DescribeNotificationRuleResult;
(function (DescribeNotificationRuleResult) {
    DescribeNotificationRuleResult.filterSensitiveLog = (obj) => ({
        ...obj,
        ...(obj.Name && { Name: smithy_client_1.SENSITIVE_STRING }),
        ...(obj.Targets && { Targets: obj.Targets.map((item) => TargetSummary.filterSensitiveLog(item)) }),
    });
})(DescribeNotificationRuleResult = exports.DescribeNotificationRuleResult || (exports.DescribeNotificationRuleResult = {}));
class ResourceNotFoundException extends CodestarNotificationsServiceException_1.CodestarNotificationsServiceException {
    constructor(opts) {
        super({
            name: "ResourceNotFoundException",
            $fault: "client",
            ...opts,
        });
        this.name = "ResourceNotFoundException";
        this.$fault = "client";
        Object.setPrototypeOf(this, ResourceNotFoundException.prototype);
        this.Message = opts.Message;
    }
}
exports.ResourceNotFoundException = ResourceNotFoundException;
class InvalidNextTokenException extends CodestarNotificationsServiceException_1.CodestarNotificationsServiceException {
    constructor(opts) {
        super({
            name: "InvalidNextTokenException",
            $fault: "client",
            ...opts,
        });
        this.name = "InvalidNextTokenException";
        this.$fault = "client";
        Object.setPrototypeOf(this, InvalidNextTokenException.prototype);
        this.Message = opts.Message;
    }
}
exports.InvalidNextTokenException = InvalidNextTokenException;
var ListEventTypesFilterName;
(function (ListEventTypesFilterName) {
    ListEventTypesFilterName["RESOURCE_TYPE"] = "RESOURCE_TYPE";
    ListEventTypesFilterName["SERVICE_NAME"] = "SERVICE_NAME";
})(ListEventTypesFilterName = exports.ListEventTypesFilterName || (exports.ListEventTypesFilterName = {}));
var ListEventTypesFilter;
(function (ListEventTypesFilter) {
    ListEventTypesFilter.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(ListEventTypesFilter = exports.ListEventTypesFilter || (exports.ListEventTypesFilter = {}));
var ListEventTypesRequest;
(function (ListEventTypesRequest) {
    ListEventTypesRequest.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(ListEventTypesRequest = exports.ListEventTypesRequest || (exports.ListEventTypesRequest = {}));
var ListEventTypesResult;
(function (ListEventTypesResult) {
    ListEventTypesResult.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(ListEventTypesResult = exports.ListEventTypesResult || (exports.ListEventTypesResult = {}));
var ListNotificationRulesFilterName;
(function (ListNotificationRulesFilterName) {
    ListNotificationRulesFilterName["CREATED_BY"] = "CREATED_BY";
    ListNotificationRulesFilterName["EVENT_TYPE_ID"] = "EVENT_TYPE_ID";
    ListNotificationRulesFilterName["RESOURCE"] = "RESOURCE";
    ListNotificationRulesFilterName["TARGET_ADDRESS"] = "TARGET_ADDRESS";
})(ListNotificationRulesFilterName = exports.ListNotificationRulesFilterName || (exports.ListNotificationRulesFilterName = {}));
var ListNotificationRulesFilter;
(function (ListNotificationRulesFilter) {
    ListNotificationRulesFilter.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(ListNotificationRulesFilter = exports.ListNotificationRulesFilter || (exports.ListNotificationRulesFilter = {}));
var ListNotificationRulesRequest;
(function (ListNotificationRulesRequest) {
    ListNotificationRulesRequest.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(ListNotificationRulesRequest = exports.ListNotificationRulesRequest || (exports.ListNotificationRulesRequest = {}));
var NotificationRuleSummary;
(function (NotificationRuleSummary) {
    NotificationRuleSummary.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(NotificationRuleSummary = exports.NotificationRuleSummary || (exports.NotificationRuleSummary = {}));
var ListNotificationRulesResult;
(function (ListNotificationRulesResult) {
    ListNotificationRulesResult.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(ListNotificationRulesResult = exports.ListNotificationRulesResult || (exports.ListNotificationRulesResult = {}));
var ListTagsForResourceRequest;
(function (ListTagsForResourceRequest) {
    ListTagsForResourceRequest.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(ListTagsForResourceRequest = exports.ListTagsForResourceRequest || (exports.ListTagsForResourceRequest = {}));
var ListTagsForResourceResult;
(function (ListTagsForResourceResult) {
    ListTagsForResourceResult.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(ListTagsForResourceResult = exports.ListTagsForResourceResult || (exports.ListTagsForResourceResult = {}));
var ListTargetsFilterName;
(function (ListTargetsFilterName) {
    ListTargetsFilterName["TARGET_ADDRESS"] = "TARGET_ADDRESS";
    ListTargetsFilterName["TARGET_STATUS"] = "TARGET_STATUS";
    ListTargetsFilterName["TARGET_TYPE"] = "TARGET_TYPE";
})(ListTargetsFilterName = exports.ListTargetsFilterName || (exports.ListTargetsFilterName = {}));
var ListTargetsFilter;
(function (ListTargetsFilter) {
    ListTargetsFilter.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(ListTargetsFilter = exports.ListTargetsFilter || (exports.ListTargetsFilter = {}));
var ListTargetsRequest;
(function (ListTargetsRequest) {
    ListTargetsRequest.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(ListTargetsRequest = exports.ListTargetsRequest || (exports.ListTargetsRequest = {}));
var ListTargetsResult;
(function (ListTargetsResult) {
    ListTargetsResult.filterSensitiveLog = (obj) => ({
        ...obj,
        ...(obj.Targets && { Targets: obj.Targets.map((item) => TargetSummary.filterSensitiveLog(item)) }),
    });
})(ListTargetsResult = exports.ListTargetsResult || (exports.ListTargetsResult = {}));
var SubscribeRequest;
(function (SubscribeRequest) {
    SubscribeRequest.filterSensitiveLog = (obj) => ({
        ...obj,
        ...(obj.Target && { Target: Target.filterSensitiveLog(obj.Target) }),
    });
})(SubscribeRequest = exports.SubscribeRequest || (exports.SubscribeRequest = {}));
var SubscribeResult;
(function (SubscribeResult) {
    SubscribeResult.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(SubscribeResult = exports.SubscribeResult || (exports.SubscribeResult = {}));
var TagResourceRequest;
(function (TagResourceRequest) {
    TagResourceRequest.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(TagResourceRequest = exports.TagResourceRequest || (exports.TagResourceRequest = {}));
var TagResourceResult;
(function (TagResourceResult) {
    TagResourceResult.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(TagResourceResult = exports.TagResourceResult || (exports.TagResourceResult = {}));
var UnsubscribeRequest;
(function (UnsubscribeRequest) {
    UnsubscribeRequest.filterSensitiveLog = (obj) => ({
        ...obj,
        ...(obj.TargetAddress && { TargetAddress: smithy_client_1.SENSITIVE_STRING }),
    });
})(UnsubscribeRequest = exports.UnsubscribeRequest || (exports.UnsubscribeRequest = {}));
var UnsubscribeResult;
(function (UnsubscribeResult) {
    UnsubscribeResult.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(UnsubscribeResult = exports.UnsubscribeResult || (exports.UnsubscribeResult = {}));
var UntagResourceRequest;
(function (UntagResourceRequest) {
    UntagResourceRequest.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(UntagResourceRequest = exports.UntagResourceRequest || (exports.UntagResourceRequest = {}));
var UntagResourceResult;
(function (UntagResourceResult) {
    UntagResourceResult.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(UntagResourceResult = exports.UntagResourceResult || (exports.UntagResourceResult = {}));
var UpdateNotificationRuleRequest;
(function (UpdateNotificationRuleRequest) {
    UpdateNotificationRuleRequest.filterSensitiveLog = (obj) => ({
        ...obj,
        ...(obj.Name && { Name: smithy_client_1.SENSITIVE_STRING }),
        ...(obj.Targets && { Targets: obj.Targets.map((item) => Target.filterSensitiveLog(item)) }),
    });
})(UpdateNotificationRuleRequest = exports.UpdateNotificationRuleRequest || (exports.UpdateNotificationRuleRequest = {}));
var UpdateNotificationRuleResult;
(function (UpdateNotificationRuleResult) {
    UpdateNotificationRuleResult.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(UpdateNotificationRuleResult = exports.UpdateNotificationRuleResult || (exports.UpdateNotificationRuleResult = {}));
