import { __extends } from "tslib";
import { CodestarNotificationsClient } from "./CodestarNotificationsClient";
import { CreateNotificationRuleCommand, } from "./commands/CreateNotificationRuleCommand";
import { DeleteNotificationRuleCommand, } from "./commands/DeleteNotificationRuleCommand";
import { DeleteTargetCommand, } from "./commands/DeleteTargetCommand";
import { DescribeNotificationRuleCommand, } from "./commands/DescribeNotificationRuleCommand";
import { ListEventTypesCommand, } from "./commands/ListEventTypesCommand";
import { ListNotificationRulesCommand, } from "./commands/ListNotificationRulesCommand";
import { ListTagsForResourceCommand, } from "./commands/ListTagsForResourceCommand";
import { ListTargetsCommand } from "./commands/ListTargetsCommand";
import { SubscribeCommand } from "./commands/SubscribeCommand";
import { TagResourceCommand } from "./commands/TagResourceCommand";
import { UnsubscribeCommand } from "./commands/UnsubscribeCommand";
import { UntagResourceCommand, } from "./commands/UntagResourceCommand";
import { UpdateNotificationRuleCommand, } from "./commands/UpdateNotificationRuleCommand";
var CodestarNotifications = (function (_super) {
    __extends(CodestarNotifications, _super);
    function CodestarNotifications() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    CodestarNotifications.prototype.createNotificationRule = function (args, optionsOrCb, cb) {
        var command = new CreateNotificationRuleCommand(args);
        if (typeof optionsOrCb === "function") {
            this.send(command, optionsOrCb);
        }
        else if (typeof cb === "function") {
            if (typeof optionsOrCb !== "object")
                throw new Error("Expect http options but get ".concat(typeof optionsOrCb));
            this.send(command, optionsOrCb || {}, cb);
        }
        else {
            return this.send(command, optionsOrCb);
        }
    };
    CodestarNotifications.prototype.deleteNotificationRule = function (args, optionsOrCb, cb) {
        var command = new DeleteNotificationRuleCommand(args);
        if (typeof optionsOrCb === "function") {
            this.send(command, optionsOrCb);
        }
        else if (typeof cb === "function") {
            if (typeof optionsOrCb !== "object")
                throw new Error("Expect http options but get ".concat(typeof optionsOrCb));
            this.send(command, optionsOrCb || {}, cb);
        }
        else {
            return this.send(command, optionsOrCb);
        }
    };
    CodestarNotifications.prototype.deleteTarget = function (args, optionsOrCb, cb) {
        var command = new DeleteTargetCommand(args);
        if (typeof optionsOrCb === "function") {
            this.send(command, optionsOrCb);
        }
        else if (typeof cb === "function") {
            if (typeof optionsOrCb !== "object")
                throw new Error("Expect http options but get ".concat(typeof optionsOrCb));
            this.send(command, optionsOrCb || {}, cb);
        }
        else {
            return this.send(command, optionsOrCb);
        }
    };
    CodestarNotifications.prototype.describeNotificationRule = function (args, optionsOrCb, cb) {
        var command = new DescribeNotificationRuleCommand(args);
        if (typeof optionsOrCb === "function") {
            this.send(command, optionsOrCb);
        }
        else if (typeof cb === "function") {
            if (typeof optionsOrCb !== "object")
                throw new Error("Expect http options but get ".concat(typeof optionsOrCb));
            this.send(command, optionsOrCb || {}, cb);
        }
        else {
            return this.send(command, optionsOrCb);
        }
    };
    CodestarNotifications.prototype.listEventTypes = function (args, optionsOrCb, cb) {
        var command = new ListEventTypesCommand(args);
        if (typeof optionsOrCb === "function") {
            this.send(command, optionsOrCb);
        }
        else if (typeof cb === "function") {
            if (typeof optionsOrCb !== "object")
                throw new Error("Expect http options but get ".concat(typeof optionsOrCb));
            this.send(command, optionsOrCb || {}, cb);
        }
        else {
            return this.send(command, optionsOrCb);
        }
    };
    CodestarNotifications.prototype.listNotificationRules = function (args, optionsOrCb, cb) {
        var command = new ListNotificationRulesCommand(args);
        if (typeof optionsOrCb === "function") {
            this.send(command, optionsOrCb);
        }
        else if (typeof cb === "function") {
            if (typeof optionsOrCb !== "object")
                throw new Error("Expect http options but get ".concat(typeof optionsOrCb));
            this.send(command, optionsOrCb || {}, cb);
        }
        else {
            return this.send(command, optionsOrCb);
        }
    };
    CodestarNotifications.prototype.listTagsForResource = function (args, optionsOrCb, cb) {
        var command = new ListTagsForResourceCommand(args);
        if (typeof optionsOrCb === "function") {
            this.send(command, optionsOrCb);
        }
        else if (typeof cb === "function") {
            if (typeof optionsOrCb !== "object")
                throw new Error("Expect http options but get ".concat(typeof optionsOrCb));
            this.send(command, optionsOrCb || {}, cb);
        }
        else {
            return this.send(command, optionsOrCb);
        }
    };
    CodestarNotifications.prototype.listTargets = function (args, optionsOrCb, cb) {
        var command = new ListTargetsCommand(args);
        if (typeof optionsOrCb === "function") {
            this.send(command, optionsOrCb);
        }
        else if (typeof cb === "function") {
            if (typeof optionsOrCb !== "object")
                throw new Error("Expect http options but get ".concat(typeof optionsOrCb));
            this.send(command, optionsOrCb || {}, cb);
        }
        else {
            return this.send(command, optionsOrCb);
        }
    };
    CodestarNotifications.prototype.subscribe = function (args, optionsOrCb, cb) {
        var command = new SubscribeCommand(args);
        if (typeof optionsOrCb === "function") {
            this.send(command, optionsOrCb);
        }
        else if (typeof cb === "function") {
            if (typeof optionsOrCb !== "object")
                throw new Error("Expect http options but get ".concat(typeof optionsOrCb));
            this.send(command, optionsOrCb || {}, cb);
        }
        else {
            return this.send(command, optionsOrCb);
        }
    };
    CodestarNotifications.prototype.tagResource = function (args, optionsOrCb, cb) {
        var command = new TagResourceCommand(args);
        if (typeof optionsOrCb === "function") {
            this.send(command, optionsOrCb);
        }
        else if (typeof cb === "function") {
            if (typeof optionsOrCb !== "object")
                throw new Error("Expect http options but get ".concat(typeof optionsOrCb));
            this.send(command, optionsOrCb || {}, cb);
        }
        else {
            return this.send(command, optionsOrCb);
        }
    };
    CodestarNotifications.prototype.unsubscribe = function (args, optionsOrCb, cb) {
        var command = new UnsubscribeCommand(args);
        if (typeof optionsOrCb === "function") {
            this.send(command, optionsOrCb);
        }
        else if (typeof cb === "function") {
            if (typeof optionsOrCb !== "object")
                throw new Error("Expect http options but get ".concat(typeof optionsOrCb));
            this.send(command, optionsOrCb || {}, cb);
        }
        else {
            return this.send(command, optionsOrCb);
        }
    };
    CodestarNotifications.prototype.untagResource = function (args, optionsOrCb, cb) {
        var command = new UntagResourceCommand(args);
        if (typeof optionsOrCb === "function") {
            this.send(command, optionsOrCb);
        }
        else if (typeof cb === "function") {
            if (typeof optionsOrCb !== "object")
                throw new Error("Expect http options but get ".concat(typeof optionsOrCb));
            this.send(command, optionsOrCb || {}, cb);
        }
        else {
            return this.send(command, optionsOrCb);
        }
    };
    CodestarNotifications.prototype.updateNotificationRule = function (args, optionsOrCb, cb) {
        var command = new UpdateNotificationRuleCommand(args);
        if (typeof optionsOrCb === "function") {
            this.send(command, optionsOrCb);
        }
        else if (typeof cb === "function") {
            if (typeof optionsOrCb !== "object")
                throw new Error("Expect http options but get ".concat(typeof optionsOrCb));
            this.send(command, optionsOrCb || {}, cb);
        }
        else {
            return this.send(command, optionsOrCb);
        }
    };
    return CodestarNotifications;
}(CodestarNotificationsClient));
export { CodestarNotifications };
