import { __extends } from "tslib";
import { getSerdePlugin } from "@aws-sdk/middleware-serde";
import { Command as $Command } from "@aws-sdk/smithy-client";
import { CreateNotificationRuleRequest, CreateNotificationRuleResult } from "../models/models_0";
import { deserializeAws_restJson1CreateNotificationRuleCommand, serializeAws_restJson1CreateNotificationRuleCommand, } from "../protocols/Aws_restJson1";
var CreateNotificationRuleCommand = (function (_super) {
    __extends(CreateNotificationRuleCommand, _super);
    function CreateNotificationRuleCommand(input) {
        var _this = _super.call(this) || this;
        _this.input = input;
        return _this;
    }
    CreateNotificationRuleCommand.prototype.resolveMiddleware = function (clientStack, configuration, options) {
        this.middlewareStack.use(getSerdePlugin(configuration, this.serialize, this.deserialize));
        var stack = clientStack.concat(this.middlewareStack);
        var logger = configuration.logger;
        var clientName = "CodestarNotificationsClient";
        var commandName = "CreateNotificationRuleCommand";
        var handlerExecutionContext = {
            logger: logger,
            clientName: clientName,
            commandName: commandName,
            inputFilterSensitiveLog: CreateNotificationRuleRequest.filterSensitiveLog,
            outputFilterSensitiveLog: CreateNotificationRuleResult.filterSensitiveLog,
        };
        var requestHandler = configuration.requestHandler;
        return stack.resolve(function (request) {
            return requestHandler.handle(request.request, options || {});
        }, handlerExecutionContext);
    };
    CreateNotificationRuleCommand.prototype.serialize = function (input, context) {
        return serializeAws_restJson1CreateNotificationRuleCommand(input, context);
    };
    CreateNotificationRuleCommand.prototype.deserialize = function (output, context) {
        return deserializeAws_restJson1CreateNotificationRuleCommand(output, context);
    };
    return CreateNotificationRuleCommand;
}($Command));
export { CreateNotificationRuleCommand };
