import { __extends } from "tslib";
import { getSerdePlugin } from "@aws-sdk/middleware-serde";
import { Command as $Command } from "@aws-sdk/smithy-client";
import { DeleteNotificationRuleRequest, DeleteNotificationRuleResult } from "../models/models_0";
import { deserializeAws_restJson1DeleteNotificationRuleCommand, serializeAws_restJson1DeleteNotificationRuleCommand, } from "../protocols/Aws_restJson1";
var DeleteNotificationRuleCommand = (function (_super) {
    __extends(DeleteNotificationRuleCommand, _super);
    function DeleteNotificationRuleCommand(input) {
        var _this = _super.call(this) || this;
        _this.input = input;
        return _this;
    }
    DeleteNotificationRuleCommand.prototype.resolveMiddleware = function (clientStack, configuration, options) {
        this.middlewareStack.use(getSerdePlugin(configuration, this.serialize, this.deserialize));
        var stack = clientStack.concat(this.middlewareStack);
        var logger = configuration.logger;
        var clientName = "CodestarNotificationsClient";
        var commandName = "DeleteNotificationRuleCommand";
        var handlerExecutionContext = {
            logger: logger,
            clientName: clientName,
            commandName: commandName,
            inputFilterSensitiveLog: DeleteNotificationRuleRequest.filterSensitiveLog,
            outputFilterSensitiveLog: DeleteNotificationRuleResult.filterSensitiveLog,
        };
        var requestHandler = configuration.requestHandler;
        return stack.resolve(function (request) {
            return requestHandler.handle(request.request, options || {});
        }, handlerExecutionContext);
    };
    DeleteNotificationRuleCommand.prototype.serialize = function (input, context) {
        return serializeAws_restJson1DeleteNotificationRuleCommand(input, context);
    };
    DeleteNotificationRuleCommand.prototype.deserialize = function (output, context) {
        return deserializeAws_restJson1DeleteNotificationRuleCommand(output, context);
    };
    return DeleteNotificationRuleCommand;
}($Command));
export { DeleteNotificationRuleCommand };
