import { __extends } from "tslib";
import { getSerdePlugin } from "@aws-sdk/middleware-serde";
import { Command as $Command } from "@aws-sdk/smithy-client";
import { DeleteTargetRequest, DeleteTargetResult } from "../models/models_0";
import { deserializeAws_restJson1DeleteTargetCommand, serializeAws_restJson1DeleteTargetCommand, } from "../protocols/Aws_restJson1";
var DeleteTargetCommand = (function (_super) {
    __extends(DeleteTargetCommand, _super);
    function DeleteTargetCommand(input) {
        var _this = _super.call(this) || this;
        _this.input = input;
        return _this;
    }
    DeleteTargetCommand.prototype.resolveMiddleware = function (clientStack, configuration, options) {
        this.middlewareStack.use(getSerdePlugin(configuration, this.serialize, this.deserialize));
        var stack = clientStack.concat(this.middlewareStack);
        var logger = configuration.logger;
        var clientName = "CodestarNotificationsClient";
        var commandName = "DeleteTargetCommand";
        var handlerExecutionContext = {
            logger: logger,
            clientName: clientName,
            commandName: commandName,
            inputFilterSensitiveLog: DeleteTargetRequest.filterSensitiveLog,
            outputFilterSensitiveLog: DeleteTargetResult.filterSensitiveLog,
        };
        var requestHandler = configuration.requestHandler;
        return stack.resolve(function (request) {
            return requestHandler.handle(request.request, options || {});
        }, handlerExecutionContext);
    };
    DeleteTargetCommand.prototype.serialize = function (input, context) {
        return serializeAws_restJson1DeleteTargetCommand(input, context);
    };
    DeleteTargetCommand.prototype.deserialize = function (output, context) {
        return deserializeAws_restJson1DeleteTargetCommand(output, context);
    };
    return DeleteTargetCommand;
}($Command));
export { DeleteTargetCommand };
