import { __extends } from "tslib";
import { getSerdePlugin } from "@aws-sdk/middleware-serde";
import { Command as $Command } from "@aws-sdk/smithy-client";
import { DescribeNotificationRuleRequest, DescribeNotificationRuleResult } from "../models/models_0";
import { deserializeAws_restJson1DescribeNotificationRuleCommand, serializeAws_restJson1DescribeNotificationRuleCommand, } from "../protocols/Aws_restJson1";
var DescribeNotificationRuleCommand = (function (_super) {
    __extends(DescribeNotificationRuleCommand, _super);
    function DescribeNotificationRuleCommand(input) {
        var _this = _super.call(this) || this;
        _this.input = input;
        return _this;
    }
    DescribeNotificationRuleCommand.prototype.resolveMiddleware = function (clientStack, configuration, options) {
        this.middlewareStack.use(getSerdePlugin(configuration, this.serialize, this.deserialize));
        var stack = clientStack.concat(this.middlewareStack);
        var logger = configuration.logger;
        var clientName = "CodestarNotificationsClient";
        var commandName = "DescribeNotificationRuleCommand";
        var handlerExecutionContext = {
            logger: logger,
            clientName: clientName,
            commandName: commandName,
            inputFilterSensitiveLog: DescribeNotificationRuleRequest.filterSensitiveLog,
            outputFilterSensitiveLog: DescribeNotificationRuleResult.filterSensitiveLog,
        };
        var requestHandler = configuration.requestHandler;
        return stack.resolve(function (request) {
            return requestHandler.handle(request.request, options || {});
        }, handlerExecutionContext);
    };
    DescribeNotificationRuleCommand.prototype.serialize = function (input, context) {
        return serializeAws_restJson1DescribeNotificationRuleCommand(input, context);
    };
    DescribeNotificationRuleCommand.prototype.deserialize = function (output, context) {
        return deserializeAws_restJson1DescribeNotificationRuleCommand(output, context);
    };
    return DescribeNotificationRuleCommand;
}($Command));
export { DescribeNotificationRuleCommand };
