import { __extends } from "tslib";
import { getSerdePlugin } from "@aws-sdk/middleware-serde";
import { Command as $Command } from "@aws-sdk/smithy-client";
import { ListEventTypesRequest, ListEventTypesResult } from "../models/models_0";
import { deserializeAws_restJson1ListEventTypesCommand, serializeAws_restJson1ListEventTypesCommand, } from "../protocols/Aws_restJson1";
var ListEventTypesCommand = (function (_super) {
    __extends(ListEventTypesCommand, _super);
    function ListEventTypesCommand(input) {
        var _this = _super.call(this) || this;
        _this.input = input;
        return _this;
    }
    ListEventTypesCommand.prototype.resolveMiddleware = function (clientStack, configuration, options) {
        this.middlewareStack.use(getSerdePlugin(configuration, this.serialize, this.deserialize));
        var stack = clientStack.concat(this.middlewareStack);
        var logger = configuration.logger;
        var clientName = "CodestarNotificationsClient";
        var commandName = "ListEventTypesCommand";
        var handlerExecutionContext = {
            logger: logger,
            clientName: clientName,
            commandName: commandName,
            inputFilterSensitiveLog: ListEventTypesRequest.filterSensitiveLog,
            outputFilterSensitiveLog: ListEventTypesResult.filterSensitiveLog,
        };
        var requestHandler = configuration.requestHandler;
        return stack.resolve(function (request) {
            return requestHandler.handle(request.request, options || {});
        }, handlerExecutionContext);
    };
    ListEventTypesCommand.prototype.serialize = function (input, context) {
        return serializeAws_restJson1ListEventTypesCommand(input, context);
    };
    ListEventTypesCommand.prototype.deserialize = function (output, context) {
        return deserializeAws_restJson1ListEventTypesCommand(output, context);
    };
    return ListEventTypesCommand;
}($Command));
export { ListEventTypesCommand };
