import { __extends } from "tslib";
import { getSerdePlugin } from "@aws-sdk/middleware-serde";
import { Command as $Command } from "@aws-sdk/smithy-client";
import { ListNotificationRulesRequest, ListNotificationRulesResult } from "../models/models_0";
import { deserializeAws_restJson1ListNotificationRulesCommand, serializeAws_restJson1ListNotificationRulesCommand, } from "../protocols/Aws_restJson1";
var ListNotificationRulesCommand = (function (_super) {
    __extends(ListNotificationRulesCommand, _super);
    function ListNotificationRulesCommand(input) {
        var _this = _super.call(this) || this;
        _this.input = input;
        return _this;
    }
    ListNotificationRulesCommand.prototype.resolveMiddleware = function (clientStack, configuration, options) {
        this.middlewareStack.use(getSerdePlugin(configuration, this.serialize, this.deserialize));
        var stack = clientStack.concat(this.middlewareStack);
        var logger = configuration.logger;
        var clientName = "CodestarNotificationsClient";
        var commandName = "ListNotificationRulesCommand";
        var handlerExecutionContext = {
            logger: logger,
            clientName: clientName,
            commandName: commandName,
            inputFilterSensitiveLog: ListNotificationRulesRequest.filterSensitiveLog,
            outputFilterSensitiveLog: ListNotificationRulesResult.filterSensitiveLog,
        };
        var requestHandler = configuration.requestHandler;
        return stack.resolve(function (request) {
            return requestHandler.handle(request.request, options || {});
        }, handlerExecutionContext);
    };
    ListNotificationRulesCommand.prototype.serialize = function (input, context) {
        return serializeAws_restJson1ListNotificationRulesCommand(input, context);
    };
    ListNotificationRulesCommand.prototype.deserialize = function (output, context) {
        return deserializeAws_restJson1ListNotificationRulesCommand(output, context);
    };
    return ListNotificationRulesCommand;
}($Command));
export { ListNotificationRulesCommand };
