import { __extends } from "tslib";
import { getSerdePlugin } from "@aws-sdk/middleware-serde";
import { Command as $Command } from "@aws-sdk/smithy-client";
import { ListTargetsRequest, ListTargetsResult } from "../models/models_0";
import { deserializeAws_restJson1ListTargetsCommand, serializeAws_restJson1ListTargetsCommand, } from "../protocols/Aws_restJson1";
var ListTargetsCommand = (function (_super) {
    __extends(ListTargetsCommand, _super);
    function ListTargetsCommand(input) {
        var _this = _super.call(this) || this;
        _this.input = input;
        return _this;
    }
    ListTargetsCommand.prototype.resolveMiddleware = function (clientStack, configuration, options) {
        this.middlewareStack.use(getSerdePlugin(configuration, this.serialize, this.deserialize));
        var stack = clientStack.concat(this.middlewareStack);
        var logger = configuration.logger;
        var clientName = "CodestarNotificationsClient";
        var commandName = "ListTargetsCommand";
        var handlerExecutionContext = {
            logger: logger,
            clientName: clientName,
            commandName: commandName,
            inputFilterSensitiveLog: ListTargetsRequest.filterSensitiveLog,
            outputFilterSensitiveLog: ListTargetsResult.filterSensitiveLog,
        };
        var requestHandler = configuration.requestHandler;
        return stack.resolve(function (request) {
            return requestHandler.handle(request.request, options || {});
        }, handlerExecutionContext);
    };
    ListTargetsCommand.prototype.serialize = function (input, context) {
        return serializeAws_restJson1ListTargetsCommand(input, context);
    };
    ListTargetsCommand.prototype.deserialize = function (output, context) {
        return deserializeAws_restJson1ListTargetsCommand(output, context);
    };
    return ListTargetsCommand;
}($Command));
export { ListTargetsCommand };
