import { __extends } from "tslib";
import { getSerdePlugin } from "@aws-sdk/middleware-serde";
import { Command as $Command } from "@aws-sdk/smithy-client";
import { UpdateNotificationRuleRequest, UpdateNotificationRuleResult } from "../models/models_0";
import { deserializeAws_restJson1UpdateNotificationRuleCommand, serializeAws_restJson1UpdateNotificationRuleCommand, } from "../protocols/Aws_restJson1";
var UpdateNotificationRuleCommand = (function (_super) {
    __extends(UpdateNotificationRuleCommand, _super);
    function UpdateNotificationRuleCommand(input) {
        var _this = _super.call(this) || this;
        _this.input = input;
        return _this;
    }
    UpdateNotificationRuleCommand.prototype.resolveMiddleware = function (clientStack, configuration, options) {
        this.middlewareStack.use(getSerdePlugin(configuration, this.serialize, this.deserialize));
        var stack = clientStack.concat(this.middlewareStack);
        var logger = configuration.logger;
        var clientName = "CodestarNotificationsClient";
        var commandName = "UpdateNotificationRuleCommand";
        var handlerExecutionContext = {
            logger: logger,
            clientName: clientName,
            commandName: commandName,
            inputFilterSensitiveLog: UpdateNotificationRuleRequest.filterSensitiveLog,
            outputFilterSensitiveLog: UpdateNotificationRuleResult.filterSensitiveLog,
        };
        var requestHandler = configuration.requestHandler;
        return stack.resolve(function (request) {
            return requestHandler.handle(request.request, options || {});
        }, handlerExecutionContext);
    };
    UpdateNotificationRuleCommand.prototype.serialize = function (input, context) {
        return serializeAws_restJson1UpdateNotificationRuleCommand(input, context);
    };
    UpdateNotificationRuleCommand.prototype.deserialize = function (output, context) {
        return deserializeAws_restJson1UpdateNotificationRuleCommand(output, context);
    };
    return UpdateNotificationRuleCommand;
}($Command));
export { UpdateNotificationRuleCommand };
