import { __assign, __extends } from "tslib";
import { SENSITIVE_STRING } from "@aws-sdk/smithy-client";
import { CodestarNotificationsServiceException as __BaseException } from "./CodestarNotificationsServiceException";
var AccessDeniedException = (function (_super) {
    __extends(AccessDeniedException, _super);
    function AccessDeniedException(opts) {
        var _this = _super.call(this, __assign({ name: "AccessDeniedException", $fault: "client" }, opts)) || this;
        _this.name = "AccessDeniedException";
        _this.$fault = "client";
        Object.setPrototypeOf(_this, AccessDeniedException.prototype);
        _this.Message = opts.Message;
        return _this;
    }
    return AccessDeniedException;
}(__BaseException));
export { AccessDeniedException };
var ConcurrentModificationException = (function (_super) {
    __extends(ConcurrentModificationException, _super);
    function ConcurrentModificationException(opts) {
        var _this = _super.call(this, __assign({ name: "ConcurrentModificationException", $fault: "client" }, opts)) || this;
        _this.name = "ConcurrentModificationException";
        _this.$fault = "client";
        Object.setPrototypeOf(_this, ConcurrentModificationException.prototype);
        _this.Message = opts.Message;
        return _this;
    }
    return ConcurrentModificationException;
}(__BaseException));
export { ConcurrentModificationException };
var ConfigurationException = (function (_super) {
    __extends(ConfigurationException, _super);
    function ConfigurationException(opts) {
        var _this = _super.call(this, __assign({ name: "ConfigurationException", $fault: "client" }, opts)) || this;
        _this.name = "ConfigurationException";
        _this.$fault = "client";
        Object.setPrototypeOf(_this, ConfigurationException.prototype);
        _this.Message = opts.Message;
        return _this;
    }
    return ConfigurationException;
}(__BaseException));
export { ConfigurationException };
export var DetailType;
(function (DetailType) {
    DetailType["BASIC"] = "BASIC";
    DetailType["FULL"] = "FULL";
})(DetailType || (DetailType = {}));
export var NotificationRuleStatus;
(function (NotificationRuleStatus) {
    NotificationRuleStatus["DISABLED"] = "DISABLED";
    NotificationRuleStatus["ENABLED"] = "ENABLED";
})(NotificationRuleStatus || (NotificationRuleStatus = {}));
export var Target;
(function (Target) {
    Target.filterSensitiveLog = function (obj) { return (__assign(__assign({}, obj), (obj.TargetAddress && { TargetAddress: SENSITIVE_STRING }))); };
})(Target || (Target = {}));
export var CreateNotificationRuleRequest;
(function (CreateNotificationRuleRequest) {
    CreateNotificationRuleRequest.filterSensitiveLog = function (obj) { return (__assign(__assign(__assign({}, obj), (obj.Name && { Name: SENSITIVE_STRING })), (obj.Targets && { Targets: obj.Targets.map(function (item) { return Target.filterSensitiveLog(item); }) }))); };
})(CreateNotificationRuleRequest || (CreateNotificationRuleRequest = {}));
export var CreateNotificationRuleResult;
(function (CreateNotificationRuleResult) {
    CreateNotificationRuleResult.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(CreateNotificationRuleResult || (CreateNotificationRuleResult = {}));
var LimitExceededException = (function (_super) {
    __extends(LimitExceededException, _super);
    function LimitExceededException(opts) {
        var _this = _super.call(this, __assign({ name: "LimitExceededException", $fault: "client" }, opts)) || this;
        _this.name = "LimitExceededException";
        _this.$fault = "client";
        Object.setPrototypeOf(_this, LimitExceededException.prototype);
        _this.Message = opts.Message;
        return _this;
    }
    return LimitExceededException;
}(__BaseException));
export { LimitExceededException };
var ResourceAlreadyExistsException = (function (_super) {
    __extends(ResourceAlreadyExistsException, _super);
    function ResourceAlreadyExistsException(opts) {
        var _this = _super.call(this, __assign({ name: "ResourceAlreadyExistsException", $fault: "client" }, opts)) || this;
        _this.name = "ResourceAlreadyExistsException";
        _this.$fault = "client";
        Object.setPrototypeOf(_this, ResourceAlreadyExistsException.prototype);
        _this.Message = opts.Message;
        return _this;
    }
    return ResourceAlreadyExistsException;
}(__BaseException));
export { ResourceAlreadyExistsException };
var ValidationException = (function (_super) {
    __extends(ValidationException, _super);
    function ValidationException(opts) {
        var _this = _super.call(this, __assign({ name: "ValidationException", $fault: "client" }, opts)) || this;
        _this.name = "ValidationException";
        _this.$fault = "client";
        Object.setPrototypeOf(_this, ValidationException.prototype);
        _this.Message = opts.Message;
        return _this;
    }
    return ValidationException;
}(__BaseException));
export { ValidationException };
export var DeleteNotificationRuleRequest;
(function (DeleteNotificationRuleRequest) {
    DeleteNotificationRuleRequest.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(DeleteNotificationRuleRequest || (DeleteNotificationRuleRequest = {}));
export var DeleteNotificationRuleResult;
(function (DeleteNotificationRuleResult) {
    DeleteNotificationRuleResult.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(DeleteNotificationRuleResult || (DeleteNotificationRuleResult = {}));
export var DeleteTargetRequest;
(function (DeleteTargetRequest) {
    DeleteTargetRequest.filterSensitiveLog = function (obj) { return (__assign(__assign({}, obj), (obj.TargetAddress && { TargetAddress: SENSITIVE_STRING }))); };
})(DeleteTargetRequest || (DeleteTargetRequest = {}));
export var DeleteTargetResult;
(function (DeleteTargetResult) {
    DeleteTargetResult.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(DeleteTargetResult || (DeleteTargetResult = {}));
export var DescribeNotificationRuleRequest;
(function (DescribeNotificationRuleRequest) {
    DescribeNotificationRuleRequest.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(DescribeNotificationRuleRequest || (DescribeNotificationRuleRequest = {}));
export var EventTypeSummary;
(function (EventTypeSummary) {
    EventTypeSummary.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(EventTypeSummary || (EventTypeSummary = {}));
export var TargetStatus;
(function (TargetStatus) {
    TargetStatus["ACTIVE"] = "ACTIVE";
    TargetStatus["DEACTIVATED"] = "DEACTIVATED";
    TargetStatus["INACTIVE"] = "INACTIVE";
    TargetStatus["PENDING"] = "PENDING";
    TargetStatus["UNREACHABLE"] = "UNREACHABLE";
})(TargetStatus || (TargetStatus = {}));
export var TargetSummary;
(function (TargetSummary) {
    TargetSummary.filterSensitiveLog = function (obj) { return (__assign(__assign({}, obj), (obj.TargetAddress && { TargetAddress: SENSITIVE_STRING }))); };
})(TargetSummary || (TargetSummary = {}));
export var DescribeNotificationRuleResult;
(function (DescribeNotificationRuleResult) {
    DescribeNotificationRuleResult.filterSensitiveLog = function (obj) { return (__assign(__assign(__assign({}, obj), (obj.Name && { Name: SENSITIVE_STRING })), (obj.Targets && { Targets: obj.Targets.map(function (item) { return TargetSummary.filterSensitiveLog(item); }) }))); };
})(DescribeNotificationRuleResult || (DescribeNotificationRuleResult = {}));
var ResourceNotFoundException = (function (_super) {
    __extends(ResourceNotFoundException, _super);
    function ResourceNotFoundException(opts) {
        var _this = _super.call(this, __assign({ name: "ResourceNotFoundException", $fault: "client" }, opts)) || this;
        _this.name = "ResourceNotFoundException";
        _this.$fault = "client";
        Object.setPrototypeOf(_this, ResourceNotFoundException.prototype);
        _this.Message = opts.Message;
        return _this;
    }
    return ResourceNotFoundException;
}(__BaseException));
export { ResourceNotFoundException };
var InvalidNextTokenException = (function (_super) {
    __extends(InvalidNextTokenException, _super);
    function InvalidNextTokenException(opts) {
        var _this = _super.call(this, __assign({ name: "InvalidNextTokenException", $fault: "client" }, opts)) || this;
        _this.name = "InvalidNextTokenException";
        _this.$fault = "client";
        Object.setPrototypeOf(_this, InvalidNextTokenException.prototype);
        _this.Message = opts.Message;
        return _this;
    }
    return InvalidNextTokenException;
}(__BaseException));
export { InvalidNextTokenException };
export var ListEventTypesFilterName;
(function (ListEventTypesFilterName) {
    ListEventTypesFilterName["RESOURCE_TYPE"] = "RESOURCE_TYPE";
    ListEventTypesFilterName["SERVICE_NAME"] = "SERVICE_NAME";
})(ListEventTypesFilterName || (ListEventTypesFilterName = {}));
export var ListEventTypesFilter;
(function (ListEventTypesFilter) {
    ListEventTypesFilter.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(ListEventTypesFilter || (ListEventTypesFilter = {}));
export var ListEventTypesRequest;
(function (ListEventTypesRequest) {
    ListEventTypesRequest.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(ListEventTypesRequest || (ListEventTypesRequest = {}));
export var ListEventTypesResult;
(function (ListEventTypesResult) {
    ListEventTypesResult.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(ListEventTypesResult || (ListEventTypesResult = {}));
export var ListNotificationRulesFilterName;
(function (ListNotificationRulesFilterName) {
    ListNotificationRulesFilterName["CREATED_BY"] = "CREATED_BY";
    ListNotificationRulesFilterName["EVENT_TYPE_ID"] = "EVENT_TYPE_ID";
    ListNotificationRulesFilterName["RESOURCE"] = "RESOURCE";
    ListNotificationRulesFilterName["TARGET_ADDRESS"] = "TARGET_ADDRESS";
})(ListNotificationRulesFilterName || (ListNotificationRulesFilterName = {}));
export var ListNotificationRulesFilter;
(function (ListNotificationRulesFilter) {
    ListNotificationRulesFilter.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(ListNotificationRulesFilter || (ListNotificationRulesFilter = {}));
export var ListNotificationRulesRequest;
(function (ListNotificationRulesRequest) {
    ListNotificationRulesRequest.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(ListNotificationRulesRequest || (ListNotificationRulesRequest = {}));
export var NotificationRuleSummary;
(function (NotificationRuleSummary) {
    NotificationRuleSummary.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(NotificationRuleSummary || (NotificationRuleSummary = {}));
export var ListNotificationRulesResult;
(function (ListNotificationRulesResult) {
    ListNotificationRulesResult.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(ListNotificationRulesResult || (ListNotificationRulesResult = {}));
export var ListTagsForResourceRequest;
(function (ListTagsForResourceRequest) {
    ListTagsForResourceRequest.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(ListTagsForResourceRequest || (ListTagsForResourceRequest = {}));
export var ListTagsForResourceResult;
(function (ListTagsForResourceResult) {
    ListTagsForResourceResult.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(ListTagsForResourceResult || (ListTagsForResourceResult = {}));
export var ListTargetsFilterName;
(function (ListTargetsFilterName) {
    ListTargetsFilterName["TARGET_ADDRESS"] = "TARGET_ADDRESS";
    ListTargetsFilterName["TARGET_STATUS"] = "TARGET_STATUS";
    ListTargetsFilterName["TARGET_TYPE"] = "TARGET_TYPE";
})(ListTargetsFilterName || (ListTargetsFilterName = {}));
export var ListTargetsFilter;
(function (ListTargetsFilter) {
    ListTargetsFilter.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(ListTargetsFilter || (ListTargetsFilter = {}));
export var ListTargetsRequest;
(function (ListTargetsRequest) {
    ListTargetsRequest.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(ListTargetsRequest || (ListTargetsRequest = {}));
export var ListTargetsResult;
(function (ListTargetsResult) {
    ListTargetsResult.filterSensitiveLog = function (obj) { return (__assign(__assign({}, obj), (obj.Targets && { Targets: obj.Targets.map(function (item) { return TargetSummary.filterSensitiveLog(item); }) }))); };
})(ListTargetsResult || (ListTargetsResult = {}));
export var SubscribeRequest;
(function (SubscribeRequest) {
    SubscribeRequest.filterSensitiveLog = function (obj) { return (__assign(__assign({}, obj), (obj.Target && { Target: Target.filterSensitiveLog(obj.Target) }))); };
})(SubscribeRequest || (SubscribeRequest = {}));
export var SubscribeResult;
(function (SubscribeResult) {
    SubscribeResult.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(SubscribeResult || (SubscribeResult = {}));
export var TagResourceRequest;
(function (TagResourceRequest) {
    TagResourceRequest.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(TagResourceRequest || (TagResourceRequest = {}));
export var TagResourceResult;
(function (TagResourceResult) {
    TagResourceResult.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(TagResourceResult || (TagResourceResult = {}));
export var UnsubscribeRequest;
(function (UnsubscribeRequest) {
    UnsubscribeRequest.filterSensitiveLog = function (obj) { return (__assign(__assign({}, obj), (obj.TargetAddress && { TargetAddress: SENSITIVE_STRING }))); };
})(UnsubscribeRequest || (UnsubscribeRequest = {}));
export var UnsubscribeResult;
(function (UnsubscribeResult) {
    UnsubscribeResult.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(UnsubscribeResult || (UnsubscribeResult = {}));
export var UntagResourceRequest;
(function (UntagResourceRequest) {
    UntagResourceRequest.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(UntagResourceRequest || (UntagResourceRequest = {}));
export var UntagResourceResult;
(function (UntagResourceResult) {
    UntagResourceResult.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(UntagResourceResult || (UntagResourceResult = {}));
export var UpdateNotificationRuleRequest;
(function (UpdateNotificationRuleRequest) {
    UpdateNotificationRuleRequest.filterSensitiveLog = function (obj) { return (__assign(__assign(__assign({}, obj), (obj.Name && { Name: SENSITIVE_STRING })), (obj.Targets && { Targets: obj.Targets.map(function (item) { return Target.filterSensitiveLog(item); }) }))); };
})(UpdateNotificationRuleRequest || (UpdateNotificationRuleRequest = {}));
export var UpdateNotificationRuleResult;
(function (UpdateNotificationRuleResult) {
    UpdateNotificationRuleResult.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(UpdateNotificationRuleResult || (UpdateNotificationRuleResult = {}));
