import { Command as $Command } from "@aws-sdk/smithy-client";
import { Handler, HttpHandlerOptions as __HttpHandlerOptions, MetadataBearer as __MetadataBearer, MiddlewareStack } from "@aws-sdk/types";
import { CodestarNotificationsClientResolvedConfig, ServiceInputTypes, ServiceOutputTypes } from "../CodestarNotificationsClient";
import { CreateNotificationRuleRequest, CreateNotificationRuleResult } from "../models/models_0";
export interface CreateNotificationRuleCommandInput extends CreateNotificationRuleRequest {
}
export interface CreateNotificationRuleCommandOutput extends CreateNotificationRuleResult, __MetadataBearer {
}

export declare class CreateNotificationRuleCommand extends $Command<CreateNotificationRuleCommandInput, CreateNotificationRuleCommandOutput, CodestarNotificationsClientResolvedConfig> {
    readonly input: CreateNotificationRuleCommandInput;
    constructor(input: CreateNotificationRuleCommandInput);
    
    resolveMiddleware(clientStack: MiddlewareStack<ServiceInputTypes, ServiceOutputTypes>, configuration: CodestarNotificationsClientResolvedConfig, options?: __HttpHandlerOptions): Handler<CreateNotificationRuleCommandInput, CreateNotificationRuleCommandOutput>;
    private serialize;
    private deserialize;
}
