import { Command as $Command } from "@aws-sdk/smithy-client";
import { Handler, HttpHandlerOptions as __HttpHandlerOptions, MetadataBearer as __MetadataBearer, MiddlewareStack } from "@aws-sdk/types";
import { CodestarNotificationsClientResolvedConfig, ServiceInputTypes, ServiceOutputTypes } from "../CodestarNotificationsClient";
import { DeleteNotificationRuleRequest, DeleteNotificationRuleResult } from "../models/models_0";
export interface DeleteNotificationRuleCommandInput extends DeleteNotificationRuleRequest {
}
export interface DeleteNotificationRuleCommandOutput extends DeleteNotificationRuleResult, __MetadataBearer {
}

export declare class DeleteNotificationRuleCommand extends $Command<DeleteNotificationRuleCommandInput, DeleteNotificationRuleCommandOutput, CodestarNotificationsClientResolvedConfig> {
    readonly input: DeleteNotificationRuleCommandInput;
    constructor(input: DeleteNotificationRuleCommandInput);
    
    resolveMiddleware(clientStack: MiddlewareStack<ServiceInputTypes, ServiceOutputTypes>, configuration: CodestarNotificationsClientResolvedConfig, options?: __HttpHandlerOptions): Handler<DeleteNotificationRuleCommandInput, DeleteNotificationRuleCommandOutput>;
    private serialize;
    private deserialize;
}
