import { Command as $Command } from "@aws-sdk/smithy-client";
import { Handler, HttpHandlerOptions as __HttpHandlerOptions, MetadataBearer as __MetadataBearer, MiddlewareStack } from "@aws-sdk/types";
import { CodestarNotificationsClientResolvedConfig, ServiceInputTypes, ServiceOutputTypes } from "../CodestarNotificationsClient";
import { DeleteTargetRequest, DeleteTargetResult } from "../models/models_0";
export interface DeleteTargetCommandInput extends DeleteTargetRequest {
}
export interface DeleteTargetCommandOutput extends DeleteTargetResult, __MetadataBearer {
}

export declare class DeleteTargetCommand extends $Command<DeleteTargetCommandInput, DeleteTargetCommandOutput, CodestarNotificationsClientResolvedConfig> {
    readonly input: DeleteTargetCommandInput;
    constructor(input: DeleteTargetCommandInput);
    
    resolveMiddleware(clientStack: MiddlewareStack<ServiceInputTypes, ServiceOutputTypes>, configuration: CodestarNotificationsClientResolvedConfig, options?: __HttpHandlerOptions): Handler<DeleteTargetCommandInput, DeleteTargetCommandOutput>;
    private serialize;
    private deserialize;
}
