import { Command as $Command } from "@aws-sdk/smithy-client";
import { Handler, HttpHandlerOptions as __HttpHandlerOptions, MetadataBearer as __MetadataBearer, MiddlewareStack } from "@aws-sdk/types";
import { CodestarNotificationsClientResolvedConfig, ServiceInputTypes, ServiceOutputTypes } from "../CodestarNotificationsClient";
import { DescribeNotificationRuleRequest, DescribeNotificationRuleResult } from "../models/models_0";
export interface DescribeNotificationRuleCommandInput extends DescribeNotificationRuleRequest {
}
export interface DescribeNotificationRuleCommandOutput extends DescribeNotificationRuleResult, __MetadataBearer {
}

export declare class DescribeNotificationRuleCommand extends $Command<DescribeNotificationRuleCommandInput, DescribeNotificationRuleCommandOutput, CodestarNotificationsClientResolvedConfig> {
    readonly input: DescribeNotificationRuleCommandInput;
    constructor(input: DescribeNotificationRuleCommandInput);
    
    resolveMiddleware(clientStack: MiddlewareStack<ServiceInputTypes, ServiceOutputTypes>, configuration: CodestarNotificationsClientResolvedConfig, options?: __HttpHandlerOptions): Handler<DescribeNotificationRuleCommandInput, DescribeNotificationRuleCommandOutput>;
    private serialize;
    private deserialize;
}
