import { Command as $Command } from "@aws-sdk/smithy-client";
import { Handler, HttpHandlerOptions as __HttpHandlerOptions, MetadataBearer as __MetadataBearer, MiddlewareStack } from "@aws-sdk/types";
import { CodestarNotificationsClientResolvedConfig, ServiceInputTypes, ServiceOutputTypes } from "../CodestarNotificationsClient";
import { ListEventTypesRequest, ListEventTypesResult } from "../models/models_0";
export interface ListEventTypesCommandInput extends ListEventTypesRequest {
}
export interface ListEventTypesCommandOutput extends ListEventTypesResult, __MetadataBearer {
}

export declare class ListEventTypesCommand extends $Command<ListEventTypesCommandInput, ListEventTypesCommandOutput, CodestarNotificationsClientResolvedConfig> {
    readonly input: ListEventTypesCommandInput;
    constructor(input: ListEventTypesCommandInput);
    
    resolveMiddleware(clientStack: MiddlewareStack<ServiceInputTypes, ServiceOutputTypes>, configuration: CodestarNotificationsClientResolvedConfig, options?: __HttpHandlerOptions): Handler<ListEventTypesCommandInput, ListEventTypesCommandOutput>;
    private serialize;
    private deserialize;
}
