import { Command as $Command } from "@aws-sdk/smithy-client";
import { Handler, HttpHandlerOptions as __HttpHandlerOptions, MetadataBearer as __MetadataBearer, MiddlewareStack } from "@aws-sdk/types";
import { CodestarNotificationsClientResolvedConfig, ServiceInputTypes, ServiceOutputTypes } from "../CodestarNotificationsClient";
import { ListNotificationRulesRequest, ListNotificationRulesResult } from "../models/models_0";
export interface ListNotificationRulesCommandInput extends ListNotificationRulesRequest {
}
export interface ListNotificationRulesCommandOutput extends ListNotificationRulesResult, __MetadataBearer {
}

export declare class ListNotificationRulesCommand extends $Command<ListNotificationRulesCommandInput, ListNotificationRulesCommandOutput, CodestarNotificationsClientResolvedConfig> {
    readonly input: ListNotificationRulesCommandInput;
    constructor(input: ListNotificationRulesCommandInput);
    
    resolveMiddleware(clientStack: MiddlewareStack<ServiceInputTypes, ServiceOutputTypes>, configuration: CodestarNotificationsClientResolvedConfig, options?: __HttpHandlerOptions): Handler<ListNotificationRulesCommandInput, ListNotificationRulesCommandOutput>;
    private serialize;
    private deserialize;
}
