import { Command as $Command } from "@aws-sdk/smithy-client";
import { Handler, HttpHandlerOptions as __HttpHandlerOptions, MetadataBearer as __MetadataBearer, MiddlewareStack } from "@aws-sdk/types";
import { CodestarNotificationsClientResolvedConfig, ServiceInputTypes, ServiceOutputTypes } from "../CodestarNotificationsClient";
import { ListTargetsRequest, ListTargetsResult } from "../models/models_0";
export interface ListTargetsCommandInput extends ListTargetsRequest {
}
export interface ListTargetsCommandOutput extends ListTargetsResult, __MetadataBearer {
}

export declare class ListTargetsCommand extends $Command<ListTargetsCommandInput, ListTargetsCommandOutput, CodestarNotificationsClientResolvedConfig> {
    readonly input: ListTargetsCommandInput;
    constructor(input: ListTargetsCommandInput);
    
    resolveMiddleware(clientStack: MiddlewareStack<ServiceInputTypes, ServiceOutputTypes>, configuration: CodestarNotificationsClientResolvedConfig, options?: __HttpHandlerOptions): Handler<ListTargetsCommandInput, ListTargetsCommandOutput>;
    private serialize;
    private deserialize;
}
