import { Command as $Command } from "@aws-sdk/smithy-client";
import { Handler, HttpHandlerOptions as __HttpHandlerOptions, MetadataBearer as __MetadataBearer, MiddlewareStack } from "@aws-sdk/types";
import { CodestarNotificationsClientResolvedConfig, ServiceInputTypes, ServiceOutputTypes } from "../CodestarNotificationsClient";
import { UpdateNotificationRuleRequest, UpdateNotificationRuleResult } from "../models/models_0";
export interface UpdateNotificationRuleCommandInput extends UpdateNotificationRuleRequest {
}
export interface UpdateNotificationRuleCommandOutput extends UpdateNotificationRuleResult, __MetadataBearer {
}

export declare class UpdateNotificationRuleCommand extends $Command<UpdateNotificationRuleCommandInput, UpdateNotificationRuleCommandOutput, CodestarNotificationsClientResolvedConfig> {
    readonly input: UpdateNotificationRuleCommandInput;
    constructor(input: UpdateNotificationRuleCommandInput);
    
    resolveMiddleware(clientStack: MiddlewareStack<ServiceInputTypes, ServiceOutputTypes>, configuration: CodestarNotificationsClientResolvedConfig, options?: __HttpHandlerOptions): Handler<UpdateNotificationRuleCommandInput, UpdateNotificationRuleCommandOutput>;
    private serialize;
    private deserialize;
}
